{% include "multiselect-page-fix.js" %}

var grid = Ext.getCmp('{{ component.grid.client_id }}');


applyMultiSelectFix(grid);
/*
 * {# Вместо выбранных записей из SelectionModel текущей страницы #}
 * {# отправляются записи из массива для всех страниц. #}
 */

function selectValue() {

    function showSelectRecordMessage() {
        Ext.Msg.show({
           title: 'Выбор элемента',
           msg: 'Выберите элемент из списка',
           buttons: Ext.Msg.OK,
           icon: Ext.MessageBox.INFO
        });
    }

    var displayText;
    var ids = grid.getCheckedIdsString();

    if (!ids) {
        showSelectRecordMessage();
        return;
    }
    
    var records = grid.getCheckedArray();
    var displayTexts = [];
    records.forEach(function (record) {
        displayTexts.push(record.get("{{ component.column_name_on_select }}"));
    });

    displayText = displayTexts.join(', ');

    var win = Ext.getCmp('{{ component.client_id }}');

    {% if component.callback_url %}
        Ext.Ajax.request({
            url: "{{ component.callback_url }}",
            success: function(res,opt) {
                result = Ext.util.JSON.decode(res.responseText)
                if (!result.success){
                    Ext.Msg.alert('Ошибка', result.message)
                }
                else {
                    win.fireEvent('closed_ok', ids);
                    win.close();
                }
            }
            ,params: Ext.applyIf(
                {id: ids},
                {% if component.action_context %}
                    {{component.action_context.json|safe}}
                {% endif %}
            )
            ,failure: function(response, opts){
                uiAjaxFailMessage();
            }
        });
    {% else %}
        win.fireEvent('closed_ok', ids, displayText);
        win.close();
    {% endif %}
}
